<template>
  <!--
    Default input container is a label tag,
    to ignore usage of "for" attribute, related to an input "id"
  -->
  <label
    :data-checked="checked"
    :class="{
      ...getElementCssClass('wrapper'),
      ...getRootElementCSSClasses()
    }"
  >

    <!--
      Hidden basic HTML input "checkbox" type
      Checkbox render can be overriden with slot, see below
    -->
    <input
      v-model="vModel"
      type="checkbox"
      :value="value"
      :name="name"
      class="hidden"
    >
    <!--
      @slot Input slot
      @binding {boolean} isChecked - Boolean that defines if input is checked
      @binding {any} value - Value for radio input
      @binding {CSSClasses} classes - The classes for "input" element (see Variantable)
    -->
    <slot
      name="input"
      :is-checked="checked"
      :value="value"
      :classes="getElementCssClass('input')"
    >
      <div
        :data-checked="checked"
        :class="getElementCssClass('input')"
      >
        <v-icon
          v-if="checked"
          name="check"
          scale="0.8"
        />
      </div>
    </slot>

    <!--
      @slot Default slot
      @binding {boolean} isChecked - Boolean that defines if input is checked
      @binding {any} value - Value for radio input
    -->
    <slot
      name="default"
      :is-checked="checked"
      :value="value"
    >
      {{ value }}
    </slot>

    <br>
  </label>
</template>

<script>
import Variantable from '#mixins/variantable/'
import VModelable from '#mixins/v-modelable/'
import ExtractsCSSClasses from '#mixins/extracts-css-classes/'
import CheckboxStyle from './style'

export default {
  name: 'CheckBoxInput',
  mixins: [
    VModelable,
    Variantable,
    ExtractsCSSClasses
  ],
  // VModelable options
  model: {
    // "sync" with checkboxModel, not value for checkbox input
    // ⚠ Now this.checkboxModel is a prop related to this.vModel, instead of this.value
    prop: 'checkboxModel'
  },
  props: {
    /**
     * Radio input name
     */
    name: {
      type: String,
      required: true
    },
    /**
     * Checkbox input value
     */
    value: {
      type: [ String, Object, Number, Boolean, Array ],
      required: true
    },
    /**
     * OVERRIDE VModelable auto-injected prop "checkboxModel"
     * => Set default value to Array. If object, must follow the pattern: { [key: String]: Boolean }
     */
    checkboxModel: {
      type: Array,
      default () {
        return []
      }
    }
  },
  computed: {
    /**
     * Returns true if checked
     */
    checked: function () {
      // Check if this.value key exists
      return this.vModel.includes(this.value)
    }
  },
  // Variantable options
  style: CheckboxStyle
}
</script>
